' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2010                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVIL Sample Program
' C_CAO
'
' 쐬 : N.Moriguchi
'
'  : 2011/02/08 
'
' FHC3312 2ch only Sample Program
' -----------------------------------------------------------------
Public Class Form_FHC3312_2CHSAMPLE

    Private m_imageCh0 As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()                   'CH0p摜i[̈
    Private m_imageCh1 As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()                   'CH1p摜i[̈
    Private m_videoCh0 As FVIL.Video.CFviVideoFHC3312 = New FVIL.Video.CFviVideoFHC3312     'CH0pFHC3312NX
    Private m_videoCh1 As FVIL.Video.CFviVideoFHC3312 = New FVIL.Video.CFviVideoFHC3312     'CH1pFHC3312NX
    Private m_ImagesCh0 As List(Of FVIL.Data.CFviImage) = New List(Of FVIL.Data.CFviImage)  'CH0pA荞ݗp摜i[̈
    Private m_ImagesCh1 As List(Of FVIL.Data.CFviImage) = New List(Of FVIL.Data.CFviImage)  'CH1pA荞ݗp摜i[̈
    Private m_timer As FVIL.CFviTimeCounter = New FVIL.CFviTimeCounter()                    'ԌvNX

    Dim intErr As Integer                                                                   'G[ԍi[ϐ
    Public m_strIniFilePath As String                                                       'init@CitpXj

    Dim m_intBufImgIndex As Integer                                                         '摜IuWFNgԍ
    Dim m_uintFrameNo As UInteger                                                           't[ԍ

    Private m_flgVideoOpened As Boolean                                                     'rfIfoCX̃I[v
    Private m_flgFreerun As Boolean                                                         't[̏

    Private Sub FormMainLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'FVIL̏
        'AvP[VNA ̊֐ĂяoăCuĂB 
        '̎ACZX̔F؂s܂BpԒłĂȀ͕KsKvL܂B 
        'sȂꍇ́AveNgꂽNX̎sł܂B
        FVIL._SetUp.InitVisionLibrary()

        'ϐ̏
        m_flgVideoOpened = False
        m_flgFreerun = False
        m_intBufImgIndex = 0

        'vԃeLXg{bNX
        TextBoxTime.Text = "0.000"
        't[eLXg{bNX
        TextBoxFreame.Text = "0"
        'Lv`[eLXg{bNX
        TextBoxSetCaptureNum.Text = "10"
        '摜mېeLXg{bNX
        TextBoxImageLockNum.Text = "5"
        '摜IuWFNgԍeLXg{bNX
        TextBoxBufImgIndex.Text = m_intBufImgIndex.ToString

        'GR[_p[^R{{bNX
        ComboBoxMode.Items.Clear()
        ComboBoxMode.Items.Add("GR[_XL[h")
        ComboBoxMode.Items.Add("GR[_CI[h")
        ComboBoxMode.SelectedIndex = 0

        ComboBoxStart.Items.Clear()
        ComboBoxStart.Items.Add("CPU")
        ComboBoxStart.Items.Add("GR[_OgK")
        ComboBoxStart.SelectedIndex = 0

        ComboBoxPhase.Items.Clear()
        ComboBoxPhase.Items.Add("AB")
        ComboBoxPhase.Items.Add("A")
        ComboBoxPhase.SelectedIndex = 0

        ComboBoxDirection.Items.Clear()
        ComboBoxDirection.Items.Add("CW")
        ComboBoxDirection.Items.Add("CCW")
        ComboBoxDirection.SelectedIndex = 0

        ComboBoxZEnable.Items.Clear()
        ComboBoxZEnable.Items.Add("gpȂ")
        ComboBoxZEnable.Items.Add("gp")
        ComboBoxZEnable.SelectedIndex = 0

        'gK[hR{{bNX
        ComboBoxTrigger.Items.Clear()
        ComboBoxTrigger.Items.Add("gK")
        ComboBoxTrigger.Items.Add("OgK")
        ComboBoxTrigger.SelectedIndex = 0

        'GR[_[[h`FbN̂݃p[^ύX
        GroupEncorderParam.Enabled = CheckEncoderMode.Checked
        '摜i[̈mیɎgp\
        ButtonSaveImageContinue.Enabled = False
    End Sub

    ''' <summary>
    ''' tH[\Jn Cxgnh
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gpmF܂B
    ''' </remarks>
    Private Sub formMain_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        'gp̊mF
        Dim licence_dialog As New dialogLicence
        If (licence_dialog.ShowDialog(Me) <> Windows.Forms.DialogResult.OK) Then
            Me.Close() 'gpȂꍇ̓TvvO̓I
            Exit Sub
        End If

        'init@CI
        fnSetIniFile()
    End Sub

    ''' <summary>
    ''' I
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' AvP[VIB
    ''' </remarks>
    Private Sub FormMainFormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        'bNꂽ܂B 
        If (m_videoCh0.ContinuousGrab.IsMemoryLocked) Then
            '荞݂̒~
            m_videoCh0.ContinuousGrab.StopCapture()
            m_videoCh0.ContinuousGrab.MemoryUnlock()
        End If
        If (m_videoCh1.ContinuousGrab.IsMemoryLocked) Then
            '荞݂̒~
            m_videoCh1.ContinuousGrab.StopCapture()
            m_videoCh1.ContinuousGrab.MemoryUnlock()
        End If
        'rfIfoCXI[vĂꍇ̓N[Y
        If (m_videoCh0.IsOpen = True) Then
            m_videoCh0.Close()
        End If
        If (m_videoCh1.IsOpen = True) Then
            m_videoCh1.Close()
        End If
        m_flgVideoOpened = False
    End Sub

    ''' <summary>
    ''' init@CI֐
    ''' </summary>
    ''' <remarks>
    ''' init@C̑I܂B
    ''' </remarks>
    Private Sub fnSetIniFile()
        Dim formbroseini As New Form_BROWSEINI  'init@Cݒ

        'init@C̑I
        m_strIniFilePath = ""

        If (Form_BROWSEINI.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            m_strIniFilePath = Form_BROWSEINI.strIniFilePath
            If (m_strIniFilePath.Length > 0) Then
                Try
                    'rfIfoCXI[vĂꍇ̓N[Y
                    m_flgVideoOpened = False
                    If (m_videoCh0.IsOpen = True) Then
                        m_videoCh0.Close()
                    End If
                    If (m_videoCh1.IsOpen = True) Then
                        m_videoCh1.Close()
                    End If

                    'foCXI[v
                    m_videoCh0.Open(-1, 0)
                    m_videoCh1.Open(-1, 1)
                    m_flgVideoOpened = True

                    'VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
                    'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                    '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                    'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                    Threading.Thread.Sleep(350)

                    'init@CR|[lgɐݒ
                    m_videoCh0.LoadIniFile(m_strIniFilePath)
                    m_videoCh1.LoadIniFile(m_strIniFilePath)

                    '捞摜𐳋K
                    m_videoCh0.ChangeImageSize(m_imageCh0)
                    m_videoCh1.ChangeImageSize(m_imageCh1)

                    'l\
                    'CZTAGR[_[h
                    Dim LineSensorMode As UInteger
                    Dim EncoderMode As UInteger
                    m_videoCh0.GetLineSensorMode(LineSensorMode, EncoderMode)
                    CheckLineSensorMode.Checked = LineSensorMode
                    CheckEncoderMode.Checked = EncoderMode

                    'GR[_[h
                    m_videoCh0.GetEncoderParam(ComboBoxMode.SelectedIndex, ComboBoxStart.SelectedIndex, ComboBoxPhase.SelectedIndex, ComboBoxDirection.SelectedIndex, ComboBoxZEnable.SelectedIndex, NumericUpDownComp1.Value, NumericUpDownComp2.Value)

                    '捞Ȃ̂ŃgK[hgKɐݒ
                    m_videoCh0.Trigger = 1
                    m_videoCh1.Trigger = 1
                    ComboBoxTrigger.SelectedIndex = 0
                    'JIԁATCN^C̎擾
                    NumericUpDownExposure.Value = m_videoCh0.ExposureTime
                    m_videoCh0.GetTriggerCycleTime(NumericUpDownCycleTime.Value)

                    'GR[_[hAGR[_p[^ύX
                    GroupEncorderParam.Enabled = CheckEncoderMode.Checked
                    '摜i[̈mیɎgp\
                    ButtonSaveImageContinue.Enabled = False
                Catch ex As Exception
                    'G[
                    intErr = m_videoCh0.ErrorCode
                    MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End Try

            End If
        Else
            'init@CȈꍇ̓TvvO̓I
            Me.Close()
            Exit Sub
        End If
    End Sub

    ''' <summary>
    ''' Grab One{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J荞݁B
    ''' </remarks>
    Private Sub ButtonGrabOne_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabOne.Click
        Dim msec As Double

        Try
            If (fnSetExpCycleTime()) Then
                m_videoCh0.ContinuousGrab.MemoryLock(m_imageCh0)  '摜bN
                m_videoCh1.ContinuousGrab.MemoryLock(m_imageCh1)  '摜bN
                '`imagẽZbg
                CFviImageViewCH0.Image = m_imageCh0
                CFviImageViewCH1.Image = m_imageCh1
                '莞ԕ\
                TextBoxTime.Enabled = True
                m_timer.Start()                             'ԑJn
                'JP荞
                m_videoCh0.ContinuousGrab.SimGrabSync(m_videoCh1.ContinuousGrab, 1)
                msec = m_timer.Stop()                       'ԑI
                TextBoxTime.Text = msec.ToString("0.000")   '莞ԕ\
                'ĕ`
                CFviImageViewCH0.Refresh()
                CFviImageViewCH1.Refresh()
            Else
                'JIԁATCN^C̐ݒ莸sׁ̈A荞ݏIB
                Exit Sub
            End If
        Catch ex As Exception
            'G[
            intErr = m_videoCh0.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Grab Continue{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' AJ荞݊JnE~B
    ''' </remarks>
    Private Sub ButtonGrabContinue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabContinue.Click
        '{^\ύX
        If (m_flgFreerun = True) Then
            'Xe[^XύX
            m_videoCh0.ContinuousGrab.StopCapture()
            m_videoCh1.ContinuousGrab.StopCapture()
            ButtonGrabContinue.Text = "Grab Continue"
            ButtonGrabOne.Enabled = True
            m_flgFreerun = False
            Timer1.Enabled = False
            'p[^ύX
            GroupTrigger.Enabled = True
        Else
            Try
                If (fnSetExpCycleTime()) Then
                    ButtonGrabContinue.Text = "Stop"
                    ButtonGrabOne.Enabled = False
                    m_flgFreerun = True
                    'p[^ύXs
                    GroupTrigger.Enabled = False
                    '莞ԕ\
                    TextBoxTime.Text = "0.000"
                    TextBoxTime.Enabled = False
                    '摜i[̈NA
                    m_ImagesCh0.Clear()
                    m_ImagesCh1.Clear()
                    For LockNum As Integer = 0 To TextBoxImageLockNum.Text
                        '摜mېi[̈ǉ
                        m_ImagesCh0.Add(New FVIL.Data.CFviImage())
                        m_ImagesCh1.Add(New FVIL.Data.CFviImage())
                        '捞摜𐳋K
                        m_videoCh0.ChangeImageSize(m_ImagesCh0(LockNum))
                        m_videoCh1.ChangeImageSize(m_ImagesCh1(LockNum))
                    Next
                    '摜i[̈Zbg
                    m_videoCh0.ContinuousGrab.Images = m_ImagesCh0
                    m_videoCh1.ContinuousGrab.Images = m_ImagesCh1

                    '摜i[̈mیɎgp\
                    ButtonSaveImageContinue.Enabled = True

                    '摜bN
                    m_videoCh0.ContinuousGrab.MemoryLock(TextBoxImageLockNum.Text)
                    m_videoCh1.ContinuousGrab.MemoryLock(TextBoxImageLockNum.Text)
                    Timer1.Interval = 50
                    Timer1.Start()
                    'AJ荞
                    m_videoCh0.ContinuousGrab.SimGrabASync(m_videoCh1.ContinuousGrab, TextBoxSetCaptureNum.Text)
                Else
                    'JIԁATCN^C̐ݒ莸sׁ̈A荞ݏIB
                    Exit Sub
                End If
            Catch ex As Exception
                'Xe[^XύX
                ButtonGrabContinue.Text = "Grab Continue"
                ButtonGrabOne.Enabled = True
                m_flgFreerun = False
                Timer1.Enabled = False
                'p[^ύX
                GroupTrigger.Enabled = True

                'G[
                intErr = m_videoCh0.ErrorCode
                MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If
        Application.DoEvents()
    End Sub

    ''' <summary>
    ''' ^C}[Cxg
    ''' </summary>
    ''' <remarks>
    ''' ^C}[ɂ\XVB
    ''' </remarks>
    Private Sub Timer1Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Try
            If (m_flgFreerun = True) Then
                If ((TextBoxSetCaptureNum.Text > m_videoCh0.ContinuousGrab.QueryCaptureNo.TotalFrameCount) Or (TextBoxSetCaptureNum.Text = 0)) Then
                    Timer1.Stop()
                    TextBoxFreame.Text = m_videoCh0.ContinuousGrab.QueryCaptureNo.TotalFrameCount  't[\XV
                    'ŐVt[Zbg
                    CFviImageViewCH0.Image = m_ImagesCh0(m_videoCh0.ContinuousGrab.QueryCaptureNo.LastFrameNo)
                    CFviImageViewCH1.Image = m_ImagesCh1(m_videoCh1.ContinuousGrab.QueryCaptureNo.LastFrameNo)
                    'ĕ`
                    CFviImageViewCH0.Refresh()
                    CFviImageViewCH1.Refresh()
                    Timer1.Start()
                    m_timer.Start()                             'ԑJn
                Else
                    Timer1.Stop()
                    TextBoxFreame.Text = m_videoCh0.ContinuousGrab.QueryCaptureNo.TotalFrameCount  't[\XV
                    'ŐVt[Zbg
                    CFviImageViewCH0.Image = m_ImagesCh0(m_videoCh0.ContinuousGrab.QueryCaptureNo.LastFrameNo)
                    CFviImageViewCH1.Image = m_ImagesCh1(m_videoCh1.ContinuousGrab.QueryCaptureNo.LastFrameNo)
                    'ĕ`
                    CFviImageViewCH0.Refresh()
                    CFviImageViewCH1.Refresh()
                    '荞݂̒~
                    m_videoCh0.ContinuousGrab.StopCapture()
                    m_videoCh1.ContinuousGrab.StopCapture()
                    'Xe[^XύX
                    ButtonGrabContinue.Text = "Grab Continue"
                    ButtonGrabOne.Enabled = True
                    m_flgFreerun = False
                    Timer1.Enabled = False
                    'p[^ύX
                    GroupTrigger.Enabled = True
                End If
            End If
        Catch ex As Exception
            'Xe[^XύX
            ButtonGrabContinue.Text = "Grab Continue"
            ButtonGrabOne.Enabled = True
            m_flgFreerun = False
            Timer1.Enabled = False
            'p[^ύX
            GroupTrigger.Enabled = True

            'G[
            intErr = m_videoCh0.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Trigger ModeR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gK[hEOgK[h̑IB
    ''' </remarks>
    Private Sub ComboBoxTrigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTrigger.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_videoCh0.Trigger = ComboBoxTrigger.SelectedIndex + 1
                m_videoCh1.Trigger = ComboBoxTrigger.SelectedIndex + 1
                'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                Threading.Thread.Sleep(350)
            End If
        Catch ex As Exception
            'G[
            intErr = m_videoCh0.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' ReLoad Ini File{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' rfIݒpinit@C̍ĐݒB
    ''' </remarks>
    Private Sub ButtonReLoadIni_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReLoadIni.Click
        't[Ȃ΁A~B
        If (m_flgFreerun = True) Then
            ButtonGrabContinue.Text = "Grab Continue"
            ButtonGrabOne.Enabled = True
            m_flgFreerun = False
            Timer1.Enabled = False
            Application.DoEvents()
        End If

        'init@CI
        fnSetIniFile()
    End Sub

    ''' <summary>
    ''' Save Image{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜ۑ
    ''' </remarks>
    Private Sub ButtonSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveImage.Click
        Dim ofdlg As SaveFileDialog = New SaveFileDialog()
        ofdlg.Filter = "摜t@C(*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat)|*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat"
        ofdlg.Filter += "|Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        ofdlg.Filter += "|Png t@C (*.png)|*.png"
        ofdlg.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        ofdlg.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        ofdlg.Filter += "|Raw t@C (*.raw)|*.raw"
        ofdlg.Filter += "|ׂẴt@C (*.*)|*.*"
        ofdlg.OverwritePrompt = True

        If (ofdlg.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            Try
                '̊֐́AȈՓIɉ摜t@C̕ۑŝׂ̂łB 
                '̊֐ŎwłȂp[^w肷Kv΁A e摜t@CANZXNX𒼐ڎgpĂB 
                Dim name As String
                Dim temp As Integer
                'gq܂ł̕Zo
                temp = ofdlg.FileName.Length - ofdlg.FileName.LastIndexOfAny(".")
                temp = ofdlg.FileName.Length - temp

                If (m_flgVideoOpened = True) Then
                    '`lỎ摜ۑ
                    name = ofdlg.FileName.Insert(temp, "_CH0")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewCH0.Image)
                    '`lP̉摜ۑ
                    name = ofdlg.FileName.Insert(temp, "_CH1")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewCH1.Image)
                End If

                'ۑt@C`Œ̏ꍇ́Aȉ̂悤ɋLq܂B
                '1) bmpt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileBmp = New FVIL.File.CFviImageFileBmp()
                'file.Save(ofdlg.FileName, m_image)

                '2) jpgt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileJpg = New FVIL.File.CFviImageFileJpg()
                'file.Save(ofdlg.FileName, m_image)

            Catch ex As FVIL.CFviException
                Dim msg As System.String = System.String.Format("CuO𔭍s܂Bcode={0} func={1}", ex.ErrorCode, ex.Function)
                Select Case (ex.ErrorCode)
                    Case FVIL.ErrorCode.NOT_SUPPORTED, _
                     FVIL.ErrorCode.INVALID_OBJECT
                        msg += vbCrLf + "T|[gĂȂ摜IuWFNgłB"
                        msg += vbCrLf + "Raw `ŕۑĂB"
                End Select
                MessageBox.Show(msg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

            End Try
        End If
    End Sub

    ''' <summary>
    ''' Save Image Continue{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜̉摜ۑ
    ''' </remarks>
    Private Sub ButtonSaveImageContinue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveImageContinue.Click
        Dim ofdlg As SaveFileDialog = New SaveFileDialog()
        ofdlg.Filter = "摜t@C(*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat)|*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat"
        ofdlg.Filter += "|Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        ofdlg.Filter += "|Png t@C (*.png)|*.png"
        ofdlg.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        ofdlg.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        ofdlg.Filter += "|Raw t@C (*.raw)|*.raw"
        ofdlg.Filter += "|ׂẴt@C (*.*)|*.*"
        ofdlg.OverwritePrompt = True

        If (ofdlg.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            Try
                '̊֐́AȈՓIɉ摜t@C̕ۑŝׂ̂łB 
                '̊֐ŎwłȂp[^w肷Kv΁A e摜t@CANZXNX𒼐ڎgpĂB 
                Dim name As String
                Dim temp As Integer
                'gq܂ł̕Zo
                temp = ofdlg.FileName.Length - ofdlg.FileName.LastIndexOfAny(".")
                temp = ofdlg.FileName.Length - temp

                If (m_flgVideoOpened = True) Then
                    For Num As Integer = 0 To TextBoxImageLockNum.Text
                        '`lỎ摜ۑ
                        name = ofdlg.FileName.Insert(temp, "_CH0_" + Num.ToString)
                        FVIL.File.Function.SaveImageFile(name, m_ImagesCh0(Num))
                        '`lP̉摜ۑ
                        name = ofdlg.FileName.Insert(temp, "_CH1_" + Num.ToString)
                        FVIL.File.Function.SaveImageFile(name, m_ImagesCh1(Num))
                    Next
                End If

                'ۑt@C`Œ̏ꍇ́Aȉ̂悤ɋLq܂B
                '1) bmpt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileBmp = New FVIL.File.CFviImageFileBmp()
                'file.Save(ofdlg.FileName, m_image)

                '2) jpgt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileJpg = New FVIL.File.CFviImageFileJpg()
                'file.Save(ofdlg.FileName, m_image)

            Catch ex As FVIL.CFviException
                Dim msg As System.String = System.String.Format("CuO𔭍s܂Bcode={0} func={1}", ex.ErrorCode, ex.Function)
                Select Case (ex.ErrorCode)
                    Case FVIL.ErrorCode.NOT_SUPPORTED, _
                     FVIL.ErrorCode.INVALID_OBJECT
                        msg += vbCrLf + "T|[gĂȂ摜IuWFNgłB"
                        msg += vbCrLf + "Raw `ŕۑĂB"
                End Select
                MessageBox.Show(msg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

            End Try
        End If
    End Sub

    ''' <summary>
    ''' x1{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' {ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMag1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMag1.Click
        '摜̕\{̎擾܂͐ݒs܂B1.0Ǝw肷Ɠ{ŕ\܂B
        '{ĺA0.5Ƃꍇ́AE1/2ƂȂAʐς1/4ɂȂ܂B
        '3.0Ƃꍇ́AE3{ƂȂAʐς9{ɂȂ܂B
        '\{̐ݒ
        CFviImageViewCH0.Display.Magnification = 1.0
        CFviImageViewCH1.Display.Magnification = 1.0
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
    End Sub

    ''' <summary>
    ''' Fit{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
    ''' </remarks>
    Private Sub ButtonFit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFit.Click
        '摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
        '\{𒲐
        CFviImageViewCH0.FitImageSize()
        CFviImageViewCH1.FitImageSize()
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
    End Sub

    ''' <summary>
    ''' {{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂B
    ''' </remarks>
    Private Sub ButtonPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonPlus.Click
        Dim Value As Double
        '{̎擾
        Value = CFviImageViewCH0.Display.Magnification
        Value = Value + 0.5
        '\{̐ݒ
        CFviImageViewCH0.Display.Magnification = Value
        CFviImageViewCH1.Display.Magnification = Value
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
    End Sub

    ''' <summary>
    ''' |{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂BA{OȉɂȂꍇ͔{0.1ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMinus.Click
        Dim Value As Double
        '{̎擾
        Value = CFviImageViewCH0.Display.Magnification
        Value = Value - 0.5
        If (Value <= 0) Then
            Value = 0.1       'Oȉݒ肷ƃG[ɂȂ̂0.1ݒ肷
        End If
        '\{̐ݒ
        CFviImageViewCH0.Display.Magnification = Value
        CFviImageViewCH1.Display.Magnification = Value
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
    End Sub

    ''' <summary>
    ''' Ascope`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ASCOPE̕\ؑւ܂B
    ''' </remarks>
    Private Sub CheckBoxAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxAscope.CheckedChanged
        'ASCOPEI[oC̐ݒ
        If (CheckBoxAscope.CheckState) Then
            'ASCOPE̕\LɂB
            CFviImageViewCH0.Display.OverlayAscope.Enable = True
            CFviImageViewCH0.Display.OverlayAscope.Active = True
            CFviImageViewCH1.Display.OverlayAscope.Enable = True
            CFviImageViewCH1.Display.OverlayAscope.Active = True
        Else
            'ASCOPE̕\𖳌ɂB
            CFviImageViewCH0.Display.OverlayAscope.Enable = False
            CFviImageViewCH0.Display.OverlayAscope.Active = False
            CFviImageViewCH1.Display.OverlayAscope.Enable = False
            CFviImageViewCH1.Display.OverlayAscope.Active = False
        End If
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
    End Sub

    ''' <summary>
    ''' GR[_[h`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' GR[_[hɕύX܂B
    ''' </remarks>
    Private Sub ChecEncoderMode_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckEncoderMode.CheckedChanged
        Try
            If (m_flgVideoOpened = True) Then
                Dim LineSensorMode As UInteger
                Dim EncoderMode As UInteger
                If (CheckLineSensorMode.Checked) Then
                    LineSensorMode = 1
                Else
                    LineSensorMode = 0
                End If
                If (CheckEncoderMode.Checked) Then
                    EncoderMode = 1
                Else
                    EncoderMode = 0
                End If
                m_videoCh0.SetLineSensorMode(LineSensorMode, EncoderMode)
                m_videoCh1.SetLineSensorMode(LineSensorMode, EncoderMode)
            End If
        Catch ex As Exception
            'G[
            intErr = m_videoCh0.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

        'GR[_[[h`FbN̂݃p[^ύX
        GroupEncorderParam.Enabled = CheckEncoderMode.Checked
    End Sub

    ''' <summary>
    ''' CZT[h`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' JݒiGA@Or CZTw肷j
    ''' </remarks>
    Private Sub CheckLineSensorMode_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckLineSensorMode.CheckedChanged
        Try
            If (m_flgVideoOpened = True) Then
                Dim LineSensorMode As UInteger
                Dim EncoderMode As UInteger
                If (CheckLineSensorMode.Checked) Then
                    LineSensorMode = 1
                Else
                    LineSensorMode = 0
                End If
                If (CheckEncoderMode.Checked) Then
                    EncoderMode = 1
                Else
                    EncoderMode = 0
                End If
                m_videoCh0.SetLineSensorMode(LineSensorMode, EncoderMode)
                m_videoCh1.SetLineSensorMode(LineSensorMode, EncoderMode)
            End If
        Catch ex As Exception
            'G[
            intErr = m_videoCh0.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    '''  GR[_p[^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' GR[_[hݒ( 0:GR[_XL[h 1:GR[_CI[h )
    ''' </remarks>
    Private Sub ComboBoxMode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxMode.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_videoCh0.SetEncoderParam(ComboBoxMode.SelectedIndex, ComboBoxStart.SelectedIndex, ComboBoxPhase.SelectedIndex, ComboBoxDirection.SelectedIndex, ComboBoxZEnable.SelectedIndex, NumericUpDownComp1.Value, NumericUpDownComp2.Value)
                m_videoCh1.SetEncoderParam(ComboBoxMode.SelectedIndex, ComboBoxStart.SelectedIndex, ComboBoxPhase.SelectedIndex, ComboBoxDirection.SelectedIndex, ComboBoxZEnable.SelectedIndex, NumericUpDownComp1.Value, NumericUpDownComp2.Value)
            End If
        Catch ex As Exception
            'G[
            intErr = m_videoCh0.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    '''  GR[_p[^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' GR[_N( 0:CPU 1:GR[_OgK )
    ''' </remarks>
    Private Sub ComboBoxStart_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxStart.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_videoCh0.SetEncoderParam(ComboBoxMode.SelectedIndex, ComboBoxStart.SelectedIndex, ComboBoxPhase.SelectedIndex, ComboBoxDirection.SelectedIndex, ComboBoxZEnable.SelectedIndex, NumericUpDownComp1.Value, NumericUpDownComp2.Value)
                m_videoCh1.SetEncoderParam(ComboBoxMode.SelectedIndex, ComboBoxStart.SelectedIndex, ComboBoxPhase.SelectedIndex, ComboBoxDirection.SelectedIndex, ComboBoxZEnable.SelectedIndex, NumericUpDownComp1.Value, NumericUpDownComp2.Value)
            End If
        Catch ex As Exception
            'G[
            intErr = m_videoCh0.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    '''  GR[_p[^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ABݒ( 0:ABA1:A )
    ''' </remarks>
    Private Sub ComboBoxPhase_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxPhase.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_videoCh0.SetEncoderParam(ComboBoxMode.SelectedIndex, ComboBoxStart.SelectedIndex, ComboBoxPhase.SelectedIndex, ComboBoxDirection.SelectedIndex, ComboBoxZEnable.SelectedIndex, NumericUpDownComp1.Value, NumericUpDownComp2.Value)
                m_videoCh1.SetEncoderParam(ComboBoxMode.SelectedIndex, ComboBoxStart.SelectedIndex, ComboBoxPhase.SelectedIndex, ComboBoxDirection.SelectedIndex, ComboBoxZEnable.SelectedIndex, NumericUpDownComp1.Value, NumericUpDownComp2.Value)
            End If
        Catch ex As Exception
            'G[
            intErr = m_videoCh0.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    '''  GR[_p[^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' pX̕( 0:CWA1:CCW )
    ''' </remarks>
    Private Sub ComboBoxDirection_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxDirection.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_videoCh0.SetEncoderParam(ComboBoxMode.SelectedIndex, ComboBoxStart.SelectedIndex, ComboBoxPhase.SelectedIndex, ComboBoxDirection.SelectedIndex, ComboBoxZEnable.SelectedIndex, NumericUpDownComp1.Value, NumericUpDownComp2.Value)
                m_videoCh1.SetEncoderParam(ComboBoxMode.SelectedIndex, ComboBoxStart.SelectedIndex, ComboBoxPhase.SelectedIndex, ComboBoxDirection.SelectedIndex, ComboBoxZEnable.SelectedIndex, NumericUpDownComp1.Value, NumericUpDownComp2.Value)
            End If
        Catch ex As Exception
            'G[
            intErr = m_videoCh0.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    '''  GR[_p[^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Zgpݒ( 0:gpȂ 1:gp )
    ''' </remarks>
    Private Sub ComboBoxZEnable_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxZEnable.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_videoCh0.SetEncoderParam(ComboBoxMode.SelectedIndex, ComboBoxStart.SelectedIndex, ComboBoxPhase.SelectedIndex, ComboBoxDirection.SelectedIndex, ComboBoxZEnable.SelectedIndex, NumericUpDownComp1.Value, NumericUpDownComp2.Value)
                m_videoCh1.SetEncoderParam(ComboBoxMode.SelectedIndex, ComboBoxStart.SelectedIndex, ComboBoxPhase.SelectedIndex, ComboBoxDirection.SelectedIndex, ComboBoxZEnable.SelectedIndex, NumericUpDownComp1.Value, NumericUpDownComp2.Value)
            End If
        Catch ex As Exception
            'G[
            intErr = m_videoCh0.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' GR[_p[^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' rWX^1
    ''' </remarks>
    Private Sub NumericUpDownComp1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownComp1.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_videoCh0.SetEncoderParam(ComboBoxMode.SelectedIndex, ComboBoxStart.SelectedIndex, ComboBoxPhase.SelectedIndex, ComboBoxDirection.SelectedIndex, ComboBoxZEnable.SelectedIndex, NumericUpDownComp1.Value, NumericUpDownComp2.Value)
                m_videoCh1.SetEncoderParam(ComboBoxMode.SelectedIndex, ComboBoxStart.SelectedIndex, ComboBoxPhase.SelectedIndex, ComboBoxDirection.SelectedIndex, ComboBoxZEnable.SelectedIndex, NumericUpDownComp1.Value, NumericUpDownComp2.Value)
            End If
        Catch ex As Exception
            'G[
            intErr = m_videoCh0.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' GR[_p[^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' rWX^2
    ''' </remarks>
    Private Sub NumericUpDownComp2_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownComp2.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_videoCh0.SetEncoderParam(ComboBoxMode.SelectedIndex, ComboBoxStart.SelectedIndex, ComboBoxPhase.SelectedIndex, ComboBoxDirection.SelectedIndex, ComboBoxZEnable.SelectedIndex, NumericUpDownComp1.Value, NumericUpDownComp2.Value)
                m_videoCh1.SetEncoderParam(ComboBoxMode.SelectedIndex, ComboBoxStart.SelectedIndex, ComboBoxPhase.SelectedIndex, ComboBoxDirection.SelectedIndex, ComboBoxZEnable.SelectedIndex, NumericUpDownComp1.Value, NumericUpDownComp2.Value)
            End If
        Catch ex As Exception
            'G[
            intErr = m_videoCh0.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' {^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜̔ԍ߂B
    ''' </remarks>
    Private Sub ButtonLeft_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLeft.Click
        Dim size As Integer

        m_intBufImgIndex = TextBoxBufImgIndex.Text - 1
        size = TextBoxImageLockNum.Text
        If (m_intBufImgIndex < 0) Then
            m_intBufImgIndex = size - 1
        End If
        If (m_intBufImgIndex < 0) Then
            m_intBufImgIndex = 0
        End If

        TextBoxBufImgIndex.Text = m_intBufImgIndex.ToString
        If (m_ImagesCh0.Count > 0) Then
            '\摜Zbg
            CFviImageViewCH0.Image = m_ImagesCh0(TextBoxBufImgIndex.Text)
            'ĕ`
            CFviImageViewCH0.Refresh()
        End If
        If (m_ImagesCh1.Count > 0) Then
            '\摜Zbg
            CFviImageViewCH1.Image = m_ImagesCh1(TextBoxBufImgIndex.Text)
            'ĕ`
            CFviImageViewCH1.Refresh()
        End If
    End Sub

    ''' <summary>
    ''' {^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜̔ԍi߂B
    ''' </remarks>
    Private Sub ButtonRight_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRight.Click
        Dim size As Integer

        m_intBufImgIndex = TextBoxBufImgIndex.Text + 1
        size = TextBoxImageLockNum.Text
        If (m_intBufImgIndex >= size) Then
            m_intBufImgIndex = 0
        End If

        TextBoxBufImgIndex.Text = m_intBufImgIndex.ToString
        If (m_ImagesCh0.Count > 0) Then
            '\摜Zbg
            CFviImageViewCH0.Image = m_ImagesCh0(TextBoxBufImgIndex.Text)
            'ĕ`
            CFviImageViewCH0.Refresh()
        End If
        If (m_ImagesCh1.Count > 0) Then
            '\摜Zbg
            CFviImageViewCH1.Image = m_ImagesCh1(TextBoxBufImgIndex.Text)
            'ĕ`
            CFviImageViewCH1.Refresh()
        End If
    End Sub

    ''' <summary>
    ''' Lv`[eLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Lv`[̃NvB
    ''' </remarks>
    Private Sub TextBoxSetCaptureNum_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxSetCaptureNum.TextChanged
        Try
            If (TextBoxSetCaptureNum.Text < 0) Then
                TextBoxSetCaptureNum.Text = 0
            End If
        Catch ex As Exception
            'G[
            'ȊO̓͂0ɏB
            TextBoxSetCaptureNum.Text = 0
        End Try
    End Sub

    ''' <summary>
    ''' 摜mېeLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜mې̃NvB
    ''' </remarks>
    Private Sub TextBoxImageLockNum_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxImageLockNum.TextChanged
        Try
            If (TextBoxImageLockNum.Text < 1) Then
                TextBoxImageLockNum.Text = 1
            End If
        Catch ex As Exception
            'G[
            'ȊO̓͂1ɏB
            TextBoxImageLockNum.Text = 1
        End Try
    End Sub

    ''' <summary>
    ''' 摜IuWFNgԍeLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜IuWFNgԍ̃NvB
    ''' </remarks>
    Private Sub TextBoxBufImgIndex_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxBufImgIndex.TextChanged
        Try
            Dim size As Integer
            size = TextBoxImageLockNum.Text
            If (TextBoxBufImgIndex.Text >= size) Then
                TextBoxBufImgIndex.Text = size - 1
            ElseIf (TextBoxBufImgIndex.Text < 0) Then
                TextBoxBufImgIndex.Text = 0
            End If
        Catch ex As Exception
            'G[
            'ȊO̓͂0ɏB
            TextBoxBufImgIndex.Text = 0
        End Try
    End Sub

    ''' <summary>
    ''' JIԁATCN^C̐ݒ֐
    ''' </summary>
    ''' <remarks>
    ''' Cycle Time  Exposure Time 傫Kv܂B
    ''' </remarks>
    Private Function fnSetExpCycleTime() As Boolean
        Try
            If (m_flgVideoOpened = True) Then
                If (NumericUpDownExposure.Value < NumericUpDownCycleTime.Value) Then
                    m_videoCh0.SetTriggerCycleTime(NumericUpDownCycleTime.Value)
                    m_videoCh1.SetTriggerCycleTime(NumericUpDownCycleTime.Value)
                    m_videoCh0.ExposureTime = NumericUpDownExposure.Value
                    m_videoCh1.ExposureTime = NumericUpDownExposure.Value
                Else
                    'G[
                    MessageBox.Show("Cycle Time  Video Exposure 傫ĉB", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return False
                End If
            End If
        Catch ex As Exception
            'G[
            intErr = m_videoCh0.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return False
        End Try
        Return True
    End Function

End Class
